/* Dictionary.c generated by valac 0.56.17, the Vala compiler
 * generated from Dictionary.vala, do not modify */

/*
 * Copyright (c) 2022 Andrew Vojak (https://avojak.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Andrew Vojak <andrew.vojak@gmail.com>
 */

#include <glib-object.h>
#include <gee.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#define WARBLE_MODELS_DICTIONARY_DICTIONARY_FILE_NAME "dictionary.txt"
#define WARBLE_MODELS_DICTIONARY_CANDIDATES_FILE_NAME "words.txt"
#define CONSTANTS_PKG_DATA_DIR "/usr/share/com.github.avojak.warble"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define WARBLE_MODELS_TYPE_DICTIONARY (warble_models_dictionary_get_type ())
#define WARBLE_MODELS_DICTIONARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WARBLE_MODELS_TYPE_DICTIONARY, WarbleModelsDictionary))
#define WARBLE_MODELS_DICTIONARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WARBLE_MODELS_TYPE_DICTIONARY, WarbleModelsDictionaryClass))
#define WARBLE_MODELS_IS_DICTIONARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WARBLE_MODELS_TYPE_DICTIONARY))
#define WARBLE_MODELS_IS_DICTIONARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WARBLE_MODELS_TYPE_DICTIONARY))
#define WARBLE_MODELS_DICTIONARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WARBLE_MODELS_TYPE_DICTIONARY, WarbleModelsDictionaryClass))

typedef struct _WarbleModelsDictionary WarbleModelsDictionary;
typedef struct _WarbleModelsDictionaryClass WarbleModelsDictionaryClass;
typedef struct _WarbleModelsDictionaryPrivate WarbleModelsDictionaryPrivate;
enum  {
	WARBLE_MODELS_DICTIONARY_0_PROPERTY,
	WARBLE_MODELS_DICTIONARY_DICTIONARY_WORDS_PROPERTY,
	WARBLE_MODELS_DICTIONARY_CANDIDATE_WORDS_PROPERTY,
	WARBLE_MODELS_DICTIONARY_NUM_PROPERTIES
};
static GParamSpec* warble_models_dictionary_properties[WARBLE_MODELS_DICTIONARY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _WarbleModelsDictionary {
	GObject parent_instance;
	WarbleModelsDictionaryPrivate * priv;
};

struct _WarbleModelsDictionaryClass {
	GObjectClass parent_class;
};

struct _WarbleModelsDictionaryPrivate {
	GeeMap* _dictionary_words;
	GeeMap* _candidate_words;
};

static gint WarbleModelsDictionary_private_offset;
static gpointer warble_models_dictionary_parent_class = NULL;

VALA_EXTERN GType warble_models_dictionary_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarbleModelsDictionary, g_object_unref)
static GeeHashMap* warble_models_dictionary_load_words_file (WarbleModelsDictionary* self,
                                                      const gchar* filename);
VALA_EXTERN gchar* warble_models_dictionary_get_word_of_the_day (WarbleModelsDictionary* self,
                                                     GDateTime* date,
                                                     gint length);
VALA_EXTERN GeeMap* warble_models_dictionary_get_candidate_words (WarbleModelsDictionary* self);
VALA_EXTERN gchar* warble_models_dictionary_get_random_word (WarbleModelsDictionary* self,
                                                 gint length);
VALA_EXTERN gboolean warble_models_dictionary_is_word_in_dictionary (WarbleModelsDictionary* self,
                                                         const gchar* word);
VALA_EXTERN GeeMap* warble_models_dictionary_get_dictionary_words (WarbleModelsDictionary* self);
VALA_EXTERN WarbleModelsDictionary* warble_models_dictionary_new (void);
VALA_EXTERN WarbleModelsDictionary* warble_models_dictionary_construct (GType object_type);
static void warble_models_dictionary_set_dictionary_words (WarbleModelsDictionary* self,
                                                    GeeMap* value);
static void warble_models_dictionary_set_candidate_words (WarbleModelsDictionary* self,
                                                   GeeMap* value);
static GObject * warble_models_dictionary_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void warble_models_dictionary_finalize (GObject * obj);
static GType warble_models_dictionary_get_type_once (void);
static void _vala_warble_models_dictionary_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_warble_models_dictionary_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);

static inline gpointer
warble_models_dictionary_get_instance_private (WarbleModelsDictionary* self)
{
	return G_STRUCT_MEMBER_P (self, WarbleModelsDictionary_private_offset);
}

static GeeHashMap*
warble_models_dictionary_load_words_file (WarbleModelsDictionary* self,
                                          const gchar* filename)
{
	GFile* file = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GeeHashMap* words = NULL;
	GeeHashMap* _tmp8_;
	GError* _inner_error0_ = NULL;
	GeeHashMap* result;
#line 46 "../src/Models/Dictionary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../src/Models/Dictionary.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 47 "../src/Models/Dictionary.vala"
	_tmp0_ = g_strconcat (CONSTANTS_PKG_DATA_DIR "/", filename, NULL);
#line 47 "../src/Models/Dictionary.vala"
	_tmp1_ = _tmp0_;
#line 47 "../src/Models/Dictionary.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 47 "../src/Models/Dictionary.vala"
	_tmp3_ = _tmp2_;
#line 47 "../src/Models/Dictionary.vala"
	_g_free0 (_tmp1_);
#line 47 "../src/Models/Dictionary.vala"
	file = _tmp3_;
#line 48 "../src/Models/Dictionary.vala"
	_tmp4_ = file;
#line 48 "../src/Models/Dictionary.vala"
	if (!g_file_query_exists (_tmp4_, NULL)) {
#line 168 "Dictionary.c"
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 49 "../src/Models/Dictionary.vala"
		_tmp5_ = file;
#line 49 "../src/Models/Dictionary.vala"
		_tmp6_ = g_file_get_path (_tmp5_);
#line 49 "../src/Models/Dictionary.vala"
		_tmp7_ = _tmp6_;
#line 49 "../src/Models/Dictionary.vala"
		g_critical ("Dictionary.vala:49: File (%s) not found", _tmp7_);
#line 49 "../src/Models/Dictionary.vala"
		_g_free0 (_tmp7_);
#line 182 "Dictionary.c"
	}
#line 51 "../src/Models/Dictionary.vala"
	_tmp8_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 51 "../src/Models/Dictionary.vala"
	words = _tmp8_;
#line 188 "Dictionary.c"
	{
		GFileInputStream* _tmp9_ = NULL;
		GFile* _tmp10_;
		GFileInputStream* _tmp11_;
		GDataInputStream* input_stream = NULL;
		GDataInputStream* _tmp12_;
		gchar* line = NULL;
#line 53 "../src/Models/Dictionary.vala"
		_tmp10_ = file;
#line 53 "../src/Models/Dictionary.vala"
		_tmp11_ = g_file_read (_tmp10_, NULL, &_inner_error0_);
#line 53 "../src/Models/Dictionary.vala"
		_tmp9_ = _tmp11_;
#line 53 "../src/Models/Dictionary.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 204 "Dictionary.c"
			goto __catch0_g_error;
		}
#line 53 "../src/Models/Dictionary.vala"
		_tmp12_ = g_data_input_stream_new ((GInputStream*) _tmp9_);
#line 53 "../src/Models/Dictionary.vala"
		input_stream = _tmp12_;
#line 55 "../src/Models/Dictionary.vala"
		while (TRUE) {
#line 213 "Dictionary.c"
			gchar* _tmp13_ = NULL;
			GDataInputStream* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			const gchar* _tmp17_;
			gint length = 0;
			const gchar* _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			GeeHashMap* _tmp21_;
			GeeHashMap* _tmp25_;
			gpointer _tmp26_;
			GeeList* _tmp27_;
			const gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
#line 55 "../src/Models/Dictionary.vala"
			_tmp14_ = input_stream;
#line 55 "../src/Models/Dictionary.vala"
			_tmp15_ = g_data_input_stream_read_line (_tmp14_, NULL, NULL, &_inner_error0_);
#line 55 "../src/Models/Dictionary.vala"
			_tmp13_ = _tmp15_;
#line 55 "../src/Models/Dictionary.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 55 "../src/Models/Dictionary.vala"
				_g_free0 (line);
#line 55 "../src/Models/Dictionary.vala"
				_g_object_unref0 (input_stream);
#line 55 "../src/Models/Dictionary.vala"
				_g_object_unref0 (_tmp9_);
#line 244 "Dictionary.c"
				goto __catch0_g_error;
			}
#line 55 "../src/Models/Dictionary.vala"
			_tmp16_ = _tmp13_;
#line 55 "../src/Models/Dictionary.vala"
			_tmp13_ = NULL;
#line 55 "../src/Models/Dictionary.vala"
			_g_free0 (line);
#line 55 "../src/Models/Dictionary.vala"
			line = _tmp16_;
#line 55 "../src/Models/Dictionary.vala"
			_tmp17_ = line;
#line 55 "../src/Models/Dictionary.vala"
			if (!(_tmp17_ != NULL)) {
#line 55 "../src/Models/Dictionary.vala"
				_g_free0 (_tmp13_);
#line 55 "../src/Models/Dictionary.vala"
				break;
#line 263 "Dictionary.c"
			}
#line 56 "../src/Models/Dictionary.vala"
			_tmp18_ = line;
#line 56 "../src/Models/Dictionary.vala"
			_tmp19_ = strlen (_tmp18_);
#line 56 "../src/Models/Dictionary.vala"
			_tmp20_ = _tmp19_;
#line 56 "../src/Models/Dictionary.vala"
			length = _tmp20_;
#line 57 "../src/Models/Dictionary.vala"
			_tmp21_ = words;
#line 57 "../src/Models/Dictionary.vala"
			if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp21_, (gpointer) ((gintptr) length))) {
#line 277 "Dictionary.c"
				GeeHashMap* _tmp22_;
				GeeArrayList* _tmp23_;
				GeeArrayList* _tmp24_;
#line 58 "../src/Models/Dictionary.vala"
				_tmp22_ = words;
#line 58 "../src/Models/Dictionary.vala"
				_tmp23_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 58 "../src/Models/Dictionary.vala"
				_tmp24_ = _tmp23_;
#line 58 "../src/Models/Dictionary.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp22_, (gpointer) ((gintptr) length), (GeeList*) _tmp24_);
#line 58 "../src/Models/Dictionary.vala"
				_g_object_unref0 (_tmp24_);
#line 291 "Dictionary.c"
			}
#line 60 "../src/Models/Dictionary.vala"
			_tmp25_ = words;
#line 60 "../src/Models/Dictionary.vala"
			_tmp26_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp25_, (gpointer) ((gintptr) length));
#line 60 "../src/Models/Dictionary.vala"
			_tmp27_ = (GeeList*) _tmp26_;
#line 60 "../src/Models/Dictionary.vala"
			_tmp28_ = line;
#line 60 "../src/Models/Dictionary.vala"
			_tmp29_ = g_utf8_strup (_tmp28_, (gssize) -1);
#line 60 "../src/Models/Dictionary.vala"
			_tmp30_ = _tmp29_;
#line 60 "../src/Models/Dictionary.vala"
			gee_collection_add ((GeeCollection*) _tmp27_, _tmp30_);
#line 60 "../src/Models/Dictionary.vala"
			_g_free0 (_tmp30_);
#line 60 "../src/Models/Dictionary.vala"
			_g_object_unref0 (_tmp27_);
#line 55 "../src/Models/Dictionary.vala"
			_g_free0 (_tmp13_);
#line 313 "Dictionary.c"
		}
#line 52 "../src/Models/Dictionary.vala"
		_g_free0 (line);
#line 52 "../src/Models/Dictionary.vala"
		_g_object_unref0 (input_stream);
#line 52 "../src/Models/Dictionary.vala"
		_g_object_unref0 (_tmp9_);
#line 321 "Dictionary.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp31_;
		const gchar* _tmp32_;
#line 52 "../src/Models/Dictionary.vala"
		e = _inner_error0_;
#line 52 "../src/Models/Dictionary.vala"
		_inner_error0_ = NULL;
#line 63 "../src/Models/Dictionary.vala"
		_tmp31_ = e;
#line 63 "../src/Models/Dictionary.vala"
		_tmp32_ = _tmp31_->message;
#line 63 "../src/Models/Dictionary.vala"
		g_critical ("Dictionary.vala:63: Error while reading file: %s", _tmp32_);
#line 52 "../src/Models/Dictionary.vala"
		_g_error_free0 (e);
#line 341 "Dictionary.c"
	}
	__finally0:
#line 52 "../src/Models/Dictionary.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 52 "../src/Models/Dictionary.vala"
		_g_object_unref0 (words);
#line 52 "../src/Models/Dictionary.vala"
		_g_object_unref0 (file);
#line 52 "../src/Models/Dictionary.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 52 "../src/Models/Dictionary.vala"
		g_clear_error (&_inner_error0_);
#line 52 "../src/Models/Dictionary.vala"
		return NULL;
#line 356 "Dictionary.c"
	}
#line 65 "../src/Models/Dictionary.vala"
	result = words;
#line 65 "../src/Models/Dictionary.vala"
	_g_object_unref0 (file);
#line 65 "../src/Models/Dictionary.vala"
	return result;
#line 364 "Dictionary.c"
}

gchar*
warble_models_dictionary_get_word_of_the_day (WarbleModelsDictionary* self,
                                              GDateTime* date,
                                              gint length)
{
	GeeMap* _tmp0_;
	gint num_eligible_words = 0;
	GeeMap* _tmp1_;
	gpointer _tmp2_;
	GeeList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GDateTime* epoch = NULL;
	GDateTime* _tmp7_;
	gint days_since_epoch = 0;
	GeeMap* _tmp8_;
	gpointer _tmp9_;
	GeeList* _tmp10_;
	gpointer _tmp11_;
	gchar* _tmp12_;
	gchar* result;
#line 73 "../src/Models/Dictionary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../src/Models/Dictionary.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 74 "../src/Models/Dictionary.vala"
	_tmp0_ = self->priv->_candidate_words;
#line 74 "../src/Models/Dictionary.vala"
	if (!gee_map_has_key (_tmp0_, (gpointer) ((gintptr) length))) {
#line 75 "../src/Models/Dictionary.vala"
		g_critical ("Dictionary.vala:75: No words in dictionary with length %d", length);
#line 399 "Dictionary.c"
	}
#line 77 "../src/Models/Dictionary.vala"
	_tmp1_ = self->priv->_candidate_words;
#line 77 "../src/Models/Dictionary.vala"
	_tmp2_ = gee_map_get (_tmp1_, (gpointer) ((gintptr) length));
#line 77 "../src/Models/Dictionary.vala"
	_tmp3_ = (GeeList*) _tmp2_;
#line 77 "../src/Models/Dictionary.vala"
	_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 77 "../src/Models/Dictionary.vala"
	_tmp5_ = _tmp4_;
#line 77 "../src/Models/Dictionary.vala"
	_tmp6_ = _tmp5_;
#line 77 "../src/Models/Dictionary.vala"
	_g_object_unref0 (_tmp3_);
#line 77 "../src/Models/Dictionary.vala"
	num_eligible_words = _tmp6_;
#line 78 "../src/Models/Dictionary.vala"
	g_debug ("Dictionary.vala:78: %d candidate words of length %d", num_eligible_words, length);
#line 79 "../src/Models/Dictionary.vala"
	_tmp7_ = g_date_time_new_local (1970, 1, 1, 0, 0, (gdouble) 0);
#line 79 "../src/Models/Dictionary.vala"
	epoch = _tmp7_;
#line 80 "../src/Models/Dictionary.vala"
	days_since_epoch = (gint) (g_date_time_difference (date, epoch) / G_TIME_SPAN_DAY);
#line 81 "../src/Models/Dictionary.vala"
	g_debug ("Dictionary.vala:81: %d days since Unix epoch", days_since_epoch);
#line 82 "../src/Models/Dictionary.vala"
	_tmp8_ = self->priv->_candidate_words;
#line 82 "../src/Models/Dictionary.vala"
	_tmp9_ = gee_map_get (_tmp8_, (gpointer) ((gintptr) length));
#line 82 "../src/Models/Dictionary.vala"
	_tmp10_ = (GeeList*) _tmp9_;
#line 82 "../src/Models/Dictionary.vala"
	_tmp11_ = gee_list_get (_tmp10_, days_since_epoch % num_eligible_words);
#line 82 "../src/Models/Dictionary.vala"
	_tmp12_ = (gchar*) _tmp11_;
#line 82 "../src/Models/Dictionary.vala"
	_g_object_unref0 (_tmp10_);
#line 82 "../src/Models/Dictionary.vala"
	result = _tmp12_;
#line 82 "../src/Models/Dictionary.vala"
	_g_date_time_unref0 (epoch);
#line 82 "../src/Models/Dictionary.vala"
	return result;
#line 445 "Dictionary.c"
}

gchar*
warble_models_dictionary_get_random_word (WarbleModelsDictionary* self,
                                          gint length)
{
	GeeMap* _tmp0_;
	gint num_eligible_words = 0;
	GeeMap* _tmp1_;
	gpointer _tmp2_;
	GeeList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GeeMap* _tmp7_;
	gpointer _tmp8_;
	GeeList* _tmp9_;
	gpointer _tmp10_;
	gchar* _tmp11_;
	gchar* result;
#line 88 "../src/Models/Dictionary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 89 "../src/Models/Dictionary.vala"
	_tmp0_ = self->priv->_candidate_words;
#line 89 "../src/Models/Dictionary.vala"
	if (!gee_map_has_key (_tmp0_, (gpointer) ((gintptr) length))) {
#line 90 "../src/Models/Dictionary.vala"
		g_critical ("Dictionary.vala:90: No words in dictionary with length %d", length);
#line 474 "Dictionary.c"
	}
#line 92 "../src/Models/Dictionary.vala"
	_tmp1_ = self->priv->_candidate_words;
#line 92 "../src/Models/Dictionary.vala"
	_tmp2_ = gee_map_get (_tmp1_, (gpointer) ((gintptr) length));
#line 92 "../src/Models/Dictionary.vala"
	_tmp3_ = (GeeList*) _tmp2_;
#line 92 "../src/Models/Dictionary.vala"
	_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 92 "../src/Models/Dictionary.vala"
	_tmp5_ = _tmp4_;
#line 92 "../src/Models/Dictionary.vala"
	_tmp6_ = _tmp5_;
#line 92 "../src/Models/Dictionary.vala"
	_g_object_unref0 (_tmp3_);
#line 92 "../src/Models/Dictionary.vala"
	num_eligible_words = _tmp6_;
#line 93 "../src/Models/Dictionary.vala"
	g_debug ("Dictionary.vala:93: %d candidate words of length %d", num_eligible_words, length);
#line 94 "../src/Models/Dictionary.vala"
	_tmp7_ = self->priv->_candidate_words;
#line 94 "../src/Models/Dictionary.vala"
	_tmp8_ = gee_map_get (_tmp7_, (gpointer) ((gintptr) length));
#line 94 "../src/Models/Dictionary.vala"
	_tmp9_ = (GeeList*) _tmp8_;
#line 94 "../src/Models/Dictionary.vala"
	_tmp10_ = gee_list_get (_tmp9_, (gint) g_random_int_range ((gint32) 0, (gint32) num_eligible_words));
#line 94 "../src/Models/Dictionary.vala"
	_tmp11_ = (gchar*) _tmp10_;
#line 94 "../src/Models/Dictionary.vala"
	_g_object_unref0 (_tmp9_);
#line 94 "../src/Models/Dictionary.vala"
	result = _tmp11_;
#line 94 "../src/Models/Dictionary.vala"
	return result;
#line 510 "Dictionary.c"
}

gboolean
warble_models_dictionary_is_word_in_dictionary (WarbleModelsDictionary* self,
                                                const gchar* word)
{
	GeeMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gpointer _tmp3_;
	GeeList* _tmp4_;
	gboolean _tmp5_;
	gboolean result;
#line 97 "../src/Models/Dictionary.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 97 "../src/Models/Dictionary.vala"
	g_return_val_if_fail (word != NULL, FALSE);
#line 98 "../src/Models/Dictionary.vala"
	_tmp0_ = self->priv->_dictionary_words;
#line 98 "../src/Models/Dictionary.vala"
	_tmp1_ = strlen (word);
#line 98 "../src/Models/Dictionary.vala"
	_tmp2_ = _tmp1_;
#line 98 "../src/Models/Dictionary.vala"
	_tmp3_ = gee_map_get (_tmp0_, (gpointer) ((gintptr) _tmp2_));
#line 98 "../src/Models/Dictionary.vala"
	_tmp4_ = (GeeList*) _tmp3_;
#line 98 "../src/Models/Dictionary.vala"
	_tmp5_ = gee_collection_contains ((GeeCollection*) _tmp4_, word);
#line 98 "../src/Models/Dictionary.vala"
	_g_object_unref0 (_tmp4_);
#line 98 "../src/Models/Dictionary.vala"
	result = _tmp5_;
#line 98 "../src/Models/Dictionary.vala"
	return result;
#line 546 "Dictionary.c"
}

WarbleModelsDictionary*
warble_models_dictionary_construct (GType object_type)
{
	WarbleModelsDictionary * self = NULL;
#line 22 "../src/Models/Dictionary.vala"
	self = (WarbleModelsDictionary*) g_object_new (object_type, NULL);
#line 22 "../src/Models/Dictionary.vala"
	return self;
#line 557 "Dictionary.c"
}

WarbleModelsDictionary*
warble_models_dictionary_new (void)
{
#line 22 "../src/Models/Dictionary.vala"
	return warble_models_dictionary_construct (WARBLE_MODELS_TYPE_DICTIONARY);
#line 565 "Dictionary.c"
}

GeeMap*
warble_models_dictionary_get_dictionary_words (WarbleModelsDictionary* self)
{
	GeeMap* result;
	GeeMap* _tmp0_;
#line 38 "../src/Models/Dictionary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/Models/Dictionary.vala"
	_tmp0_ = self->priv->_dictionary_words;
#line 38 "../src/Models/Dictionary.vala"
	result = _tmp0_;
#line 38 "../src/Models/Dictionary.vala"
	return result;
#line 581 "Dictionary.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 38 "../src/Models/Dictionary.vala"
	return self ? g_object_ref (self) : NULL;
#line 589 "Dictionary.c"
}

static void
warble_models_dictionary_set_dictionary_words (WarbleModelsDictionary* self,
                                               GeeMap* value)
{
	GeeMap* old_value;
#line 38 "../src/Models/Dictionary.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Models/Dictionary.vala"
	old_value = warble_models_dictionary_get_dictionary_words (self);
#line 38 "../src/Models/Dictionary.vala"
	if (old_value != value) {
#line 603 "Dictionary.c"
		GeeMap* _tmp0_;
#line 38 "../src/Models/Dictionary.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 38 "../src/Models/Dictionary.vala"
		_g_object_unref0 (self->priv->_dictionary_words);
#line 38 "../src/Models/Dictionary.vala"
		self->priv->_dictionary_words = _tmp0_;
#line 38 "../src/Models/Dictionary.vala"
		g_object_notify_by_pspec ((GObject *) self, warble_models_dictionary_properties[WARBLE_MODELS_DICTIONARY_DICTIONARY_WORDS_PROPERTY]);
#line 613 "Dictionary.c"
	}
}

GeeMap*
warble_models_dictionary_get_candidate_words (WarbleModelsDictionary* self)
{
	GeeMap* result;
	GeeMap* _tmp0_;
#line 39 "../src/Models/Dictionary.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/Models/Dictionary.vala"
	_tmp0_ = self->priv->_candidate_words;
#line 39 "../src/Models/Dictionary.vala"
	result = _tmp0_;
#line 39 "../src/Models/Dictionary.vala"
	return result;
#line 630 "Dictionary.c"
}

static void
warble_models_dictionary_set_candidate_words (WarbleModelsDictionary* self,
                                              GeeMap* value)
{
	GeeMap* old_value;
#line 39 "../src/Models/Dictionary.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Models/Dictionary.vala"
	old_value = warble_models_dictionary_get_candidate_words (self);
#line 39 "../src/Models/Dictionary.vala"
	if (old_value != value) {
#line 644 "Dictionary.c"
		GeeMap* _tmp0_;
#line 39 "../src/Models/Dictionary.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 39 "../src/Models/Dictionary.vala"
		_g_object_unref0 (self->priv->_candidate_words);
#line 39 "../src/Models/Dictionary.vala"
		self->priv->_candidate_words = _tmp0_;
#line 39 "../src/Models/Dictionary.vala"
		g_object_notify_by_pspec ((GObject *) self, warble_models_dictionary_properties[WARBLE_MODELS_DICTIONARY_CANDIDATE_WORDS_PROPERTY]);
#line 654 "Dictionary.c"
	}
}

static GObject *
warble_models_dictionary_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WarbleModelsDictionary * self;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
#line 41 "../src/Models/Dictionary.vala"
	parent_class = G_OBJECT_CLASS (warble_models_dictionary_parent_class);
#line 41 "../src/Models/Dictionary.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 41 "../src/Models/Dictionary.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARBLE_MODELS_TYPE_DICTIONARY, WarbleModelsDictionary);
#line 42 "../src/Models/Dictionary.vala"
	_tmp0_ = warble_models_dictionary_load_words_file (self, WARBLE_MODELS_DICTIONARY_DICTIONARY_FILE_NAME);
#line 42 "../src/Models/Dictionary.vala"
	_tmp1_ = _tmp0_;
#line 42 "../src/Models/Dictionary.vala"
	warble_models_dictionary_set_dictionary_words (self, (GeeMap*) _tmp1_);
#line 42 "../src/Models/Dictionary.vala"
	_g_object_unref0 (_tmp1_);
#line 43 "../src/Models/Dictionary.vala"
	_tmp2_ = warble_models_dictionary_load_words_file (self, WARBLE_MODELS_DICTIONARY_CANDIDATES_FILE_NAME);
#line 43 "../src/Models/Dictionary.vala"
	_tmp3_ = _tmp2_;
#line 43 "../src/Models/Dictionary.vala"
	warble_models_dictionary_set_candidate_words (self, (GeeMap*) _tmp3_);
#line 43 "../src/Models/Dictionary.vala"
	_g_object_unref0 (_tmp3_);
#line 41 "../src/Models/Dictionary.vala"
	return obj;
#line 694 "Dictionary.c"
}

static void
warble_models_dictionary_class_init (WarbleModelsDictionaryClass * klass,
                                     gpointer klass_data)
{
#line 22 "../src/Models/Dictionary.vala"
	warble_models_dictionary_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Models/Dictionary.vala"
	g_type_class_adjust_private_offset (klass, &WarbleModelsDictionary_private_offset);
#line 22 "../src/Models/Dictionary.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_warble_models_dictionary_get_property;
#line 22 "../src/Models/Dictionary.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_warble_models_dictionary_set_property;
#line 22 "../src/Models/Dictionary.vala"
	G_OBJECT_CLASS (klass)->constructor = warble_models_dictionary_constructor;
#line 22 "../src/Models/Dictionary.vala"
	G_OBJECT_CLASS (klass)->finalize = warble_models_dictionary_finalize;
#line 22 "../src/Models/Dictionary.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARBLE_MODELS_DICTIONARY_DICTIONARY_WORDS_PROPERTY, warble_models_dictionary_properties[WARBLE_MODELS_DICTIONARY_DICTIONARY_WORDS_PROPERTY] = g_param_spec_object ("dictionary-words", "dictionary-words", "dictionary-words", GEE_TYPE_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Models/Dictionary.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARBLE_MODELS_DICTIONARY_CANDIDATE_WORDS_PROPERTY, warble_models_dictionary_properties[WARBLE_MODELS_DICTIONARY_CANDIDATE_WORDS_PROPERTY] = g_param_spec_object ("candidate-words", "candidate-words", "candidate-words", GEE_TYPE_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 717 "Dictionary.c"
}

static void
warble_models_dictionary_instance_init (WarbleModelsDictionary * self,
                                        gpointer klass)
{
#line 22 "../src/Models/Dictionary.vala"
	self->priv = warble_models_dictionary_get_instance_private (self);
#line 726 "Dictionary.c"
}

static void
warble_models_dictionary_finalize (GObject * obj)
{
	WarbleModelsDictionary * self;
#line 22 "../src/Models/Dictionary.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARBLE_MODELS_TYPE_DICTIONARY, WarbleModelsDictionary);
#line 38 "../src/Models/Dictionary.vala"
	_g_object_unref0 (self->priv->_dictionary_words);
#line 39 "../src/Models/Dictionary.vala"
	_g_object_unref0 (self->priv->_candidate_words);
#line 22 "../src/Models/Dictionary.vala"
	G_OBJECT_CLASS (warble_models_dictionary_parent_class)->finalize (obj);
#line 741 "Dictionary.c"
}

static GType
warble_models_dictionary_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WarbleModelsDictionaryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) warble_models_dictionary_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WarbleModelsDictionary), 0, (GInstanceInitFunc) warble_models_dictionary_instance_init, NULL };
	GType warble_models_dictionary_type_id;
	warble_models_dictionary_type_id = g_type_register_static (G_TYPE_OBJECT, "WarbleModelsDictionary", &g_define_type_info, 0);
	WarbleModelsDictionary_private_offset = g_type_add_instance_private (warble_models_dictionary_type_id, sizeof (WarbleModelsDictionaryPrivate));
	return warble_models_dictionary_type_id;
}

GType
warble_models_dictionary_get_type (void)
{
	static volatile gsize warble_models_dictionary_type_id__once = 0;
	if (g_once_init_enter (&warble_models_dictionary_type_id__once)) {
		GType warble_models_dictionary_type_id;
		warble_models_dictionary_type_id = warble_models_dictionary_get_type_once ();
		g_once_init_leave (&warble_models_dictionary_type_id__once, warble_models_dictionary_type_id);
	}
	return warble_models_dictionary_type_id__once;
}

static void
_vala_warble_models_dictionary_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	WarbleModelsDictionary * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARBLE_MODELS_TYPE_DICTIONARY, WarbleModelsDictionary);
#line 22 "../src/Models/Dictionary.vala"
	switch (property_id) {
#line 22 "../src/Models/Dictionary.vala"
		case WARBLE_MODELS_DICTIONARY_DICTIONARY_WORDS_PROPERTY:
#line 22 "../src/Models/Dictionary.vala"
		g_value_set_object (value, warble_models_dictionary_get_dictionary_words (self));
#line 22 "../src/Models/Dictionary.vala"
		break;
#line 22 "../src/Models/Dictionary.vala"
		case WARBLE_MODELS_DICTIONARY_CANDIDATE_WORDS_PROPERTY:
#line 22 "../src/Models/Dictionary.vala"
		g_value_set_object (value, warble_models_dictionary_get_candidate_words (self));
#line 22 "../src/Models/Dictionary.vala"
		break;
#line 788 "Dictionary.c"
		default:
#line 22 "../src/Models/Dictionary.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Models/Dictionary.vala"
		break;
#line 794 "Dictionary.c"
	}
}

static void
_vala_warble_models_dictionary_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	WarbleModelsDictionary * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARBLE_MODELS_TYPE_DICTIONARY, WarbleModelsDictionary);
#line 22 "../src/Models/Dictionary.vala"
	switch (property_id) {
#line 22 "../src/Models/Dictionary.vala"
		case WARBLE_MODELS_DICTIONARY_DICTIONARY_WORDS_PROPERTY:
#line 22 "../src/Models/Dictionary.vala"
		warble_models_dictionary_set_dictionary_words (self, g_value_get_object (value));
#line 22 "../src/Models/Dictionary.vala"
		break;
#line 22 "../src/Models/Dictionary.vala"
		case WARBLE_MODELS_DICTIONARY_CANDIDATE_WORDS_PROPERTY:
#line 22 "../src/Models/Dictionary.vala"
		warble_models_dictionary_set_candidate_words (self, g_value_get_object (value));
#line 22 "../src/Models/Dictionary.vala"
		break;
#line 820 "Dictionary.c"
		default:
#line 22 "../src/Models/Dictionary.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Models/Dictionary.vala"
		break;
#line 826 "Dictionary.c"
	}
}

