/* Key.c generated by valac 0.56.17, the Vala compiler
 * generated from Key.vala, do not modify */

/*
 * Copyright (c) 2022 Andrew Vojak (https://avojak.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Andrew Vojak <andrew.vojak@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <cairo-gobject.h>
#include <granite.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

#define CONSTANTS_APP_ID "com.github.avojak.warble"
#define WARBLE_WIDGETS_KEY_KEY_IMAGE_SIZE 32
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define WARBLE_WIDGETS_TYPE_KEY (warble_widgets_key_get_type ())
#define WARBLE_WIDGETS_KEY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WARBLE_WIDGETS_TYPE_KEY, WarbleWidgetsKey))
#define WARBLE_WIDGETS_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WARBLE_WIDGETS_TYPE_KEY, WarbleWidgetsKeyClass))
#define WARBLE_WIDGETS_IS_KEY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WARBLE_WIDGETS_TYPE_KEY))
#define WARBLE_WIDGETS_IS_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WARBLE_WIDGETS_TYPE_KEY))
#define WARBLE_WIDGETS_KEY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WARBLE_WIDGETS_TYPE_KEY, WarbleWidgetsKeyClass))

typedef struct _WarbleWidgetsKey WarbleWidgetsKey;
typedef struct _WarbleWidgetsKeyClass WarbleWidgetsKeyClass;
typedef struct _WarbleWidgetsKeyPrivate WarbleWidgetsKeyPrivate;
typedef enum  {
	WARBLE_MODELS_STATE_BLANK,
	WARBLE_MODELS_STATE_CORRECT,
	WARBLE_MODELS_STATE_INCORRECT,
	WARBLE_MODELS_STATE_CLOSE
} WarbleModelsState;

#define WARBLE_MODELS_TYPE_STATE (warble_models_state_get_type ())

#define WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE (warble_widgets_key_key_image_get_type ())
#define WARBLE_WIDGETS_KEY_KEY_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE, WarbleWidgetsKeyKeyImage))
#define WARBLE_WIDGETS_KEY_KEY_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE, WarbleWidgetsKeyKeyImageClass))
#define WARBLE_WIDGETS_KEY_IS_KEY_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE))
#define WARBLE_WIDGETS_KEY_IS_KEY_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE))
#define WARBLE_WIDGETS_KEY_KEY_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE, WarbleWidgetsKeyKeyImageClass))

typedef struct _WarbleWidgetsKeyKeyImage WarbleWidgetsKeyKeyImage;
typedef struct _WarbleWidgetsKeyKeyImageClass WarbleWidgetsKeyKeyImageClass;
enum  {
	WARBLE_WIDGETS_KEY_0_PROPERTY,
	WARBLE_WIDGETS_KEY_LETTER_PROPERTY,
	WARBLE_WIDGETS_KEY_STATE_PROPERTY,
	WARBLE_WIDGETS_KEY_NUM_PROPERTIES
};
static GParamSpec* warble_widgets_key_properties[WARBLE_WIDGETS_KEY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _WarbleWidgetsKeyKeyImagePrivate WarbleWidgetsKeyKeyImagePrivate;
enum  {
	WARBLE_WIDGETS_KEY_KEY_IMAGE_0_PROPERTY,
	WARBLE_WIDGETS_KEY_KEY_IMAGE_LETTER_PROPERTY,
	WARBLE_WIDGETS_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY,
	WARBLE_WIDGETS_KEY_KEY_IMAGE_NUM_PROPERTIES
};
static GParamSpec* warble_widgets_key_key_image_properties[WARBLE_WIDGETS_KEY_KEY_IMAGE_NUM_PROPERTIES];
typedef enum  {
	WARBLE_COLOR_PALETTE_TEXT_COLOR
} WarbleColorPalette;

#define WARBLE_TYPE_COLOR_PALETTE (warble_color_palette_get_type ())
enum  {
	WARBLE_WIDGETS_KEY_CLICKED_SIGNAL,
	WARBLE_WIDGETS_KEY_NUM_SIGNALS
};
static guint warble_widgets_key_signals[WARBLE_WIDGETS_KEY_NUM_SIGNALS] = {0};

struct _WarbleWidgetsKey {
	GtkEventBox parent_instance;
	WarbleWidgetsKeyPrivate * priv;
};

struct _WarbleWidgetsKeyClass {
	GtkEventBoxClass parent_class;
};

struct _WarbleWidgetsKeyPrivate {
	gchar _letter;
	WarbleModelsState _state;
	WarbleWidgetsKeyKeyImage* key;
	gboolean is_pressed;
};

struct _WarbleWidgetsKeyKeyImage {
	GtkImage parent_instance;
	WarbleWidgetsKeyKeyImagePrivate * priv;
};

struct _WarbleWidgetsKeyKeyImageClass {
	GtkImageClass parent_class;
};

struct _WarbleWidgetsKeyKeyImagePrivate {
	gchar _letter;
	gint _y_offset;
};

static gint WarbleWidgetsKey_private_offset;
static gpointer warble_widgets_key_parent_class = NULL;
VALA_EXTERN GSettings* warble_application_settings;
static gint WarbleWidgetsKeyKeyImage_private_offset;
static gpointer warble_widgets_key_key_image_parent_class = NULL;

VALA_EXTERN GType warble_widgets_key_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarbleWidgetsKey, g_object_unref)
VALA_EXTERN GType warble_models_state_get_type (void) G_GNUC_CONST ;
static GType warble_widgets_key_key_image_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarbleWidgetsKeyKeyImage, g_object_unref)
VALA_EXTERN WarbleWidgetsKey* warble_widgets_key_new (gchar letter);
VALA_EXTERN WarbleWidgetsKey* warble_widgets_key_construct (GType object_type,
                                                gchar letter);
static void warble_widgets_key_update_icon (WarbleWidgetsKey* self);
VALA_EXTERN WarbleModelsState warble_widgets_key_get_state (WarbleWidgetsKey* self);
VALA_EXTERN gchar warble_widgets_key_get_letter (WarbleWidgetsKey* self);
static void warble_widgets_key_set_letter (WarbleWidgetsKey* self,
                                    gchar value);
VALA_EXTERN void warble_widgets_key_set_state (WarbleWidgetsKey* self,
                                   WarbleModelsState value);
static WarbleWidgetsKeyKeyImage* warble_widgets_key_key_image_new (gchar letter);
static WarbleWidgetsKeyKeyImage* warble_widgets_key_key_image_construct (GType object_type,
                                                                  gchar letter);
static gboolean warble_widgets_key_key_image_real_draw (GtkWidget* base,
                                                 cairo_t* ctx);
static void warble_widgets_key_key_image_draw_letter (WarbleWidgetsKeyKeyImage* self,
                                               cairo_t* ctx);
VALA_EXTERN GType warble_color_palette_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* warble_color_palette_get_value (WarbleColorPalette self);
static gchar warble_widgets_key_key_image_get_letter (WarbleWidgetsKeyKeyImage* self);
static gint warble_widgets_key_key_image_get_y_offset (WarbleWidgetsKeyKeyImage* self);
static void warble_widgets_key_key_image_set_letter (WarbleWidgetsKeyKeyImage* self,
                                              gchar value);
static void warble_widgets_key_key_image_set_y_offset (WarbleWidgetsKeyKeyImage* self,
                                                gint value);
static void warble_widgets_key_key_image_finalize (GObject * obj);
static GType warble_widgets_key_key_image_get_type_once (void);
static void _vala_warble_widgets_key_key_image_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_warble_widgets_key_key_image_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
static GObject * warble_widgets_key_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static gboolean _warble_widgets_key___lambda15_ (WarbleWidgetsKey* self,
                                          GdkEventButton* event);
static gboolean __warble_widgets_key___lambda15__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                         GdkEventButton* event,
                                                                         gpointer self);
static gboolean _warble_widgets_key___lambda16_ (WarbleWidgetsKey* self);
static gboolean __warble_widgets_key___lambda16__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                           GdkEventButton* event,
                                                                           gpointer self);
static gboolean _warble_widgets_key___lambda17_ (WarbleWidgetsKey* self);
static gboolean __warble_widgets_key___lambda17__gtk_widget_touch_event (GtkWidget* _sender,
                                                                  GdkEvent* event,
                                                                  gpointer self);
static void _warble_widgets_key___lambda18_ (WarbleWidgetsKey* self,
                                      const gchar* key);
static void __warble_widgets_key___lambda18__g_settings_changed (GSettings* _sender,
                                                          const gchar* key,
                                                          gpointer self);
static void warble_widgets_key_finalize (GObject * obj);
static GType warble_widgets_key_get_type_once (void);
static void _vala_warble_widgets_key_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_warble_widgets_key_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
warble_widgets_key_get_instance_private (WarbleWidgetsKey* self)
{
	return G_STRUCT_MEMBER_P (self, WarbleWidgetsKey_private_offset);
}

WarbleWidgetsKey*
warble_widgets_key_construct (GType object_type,
                              gchar letter)
{
	WarbleWidgetsKey * self = NULL;
#line 79 "../src/Widgets/Key.vala"
	self = (WarbleWidgetsKey*) g_object_new (object_type, "letter", letter, NULL);
#line 78 "../src/Widgets/Key.vala"
	return self;
#line 235 "Key.c"
}

WarbleWidgetsKey*
warble_widgets_key_new (gchar letter)
{
#line 78 "../src/Widgets/Key.vala"
	return warble_widgets_key_construct (WARBLE_WIDGETS_TYPE_KEY, letter);
#line 243 "Key.c"
}

static void
warble_widgets_key_update_icon (WarbleWidgetsKey* self)
{
	gboolean high_contrast_mode = FALSE;
	GSettings* _tmp0_;
	WarbleModelsState _tmp1_;
	WarbleModelsState _tmp2_;
#line 118 "../src/Widgets/Key.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/Widgets/Key.vala"
	_tmp0_ = warble_application_settings;
#line 119 "../src/Widgets/Key.vala"
	high_contrast_mode = g_settings_get_boolean (_tmp0_, "high-contrast-mode");
#line 120 "../src/Widgets/Key.vala"
	_tmp1_ = warble_widgets_key_get_state (self);
#line 120 "../src/Widgets/Key.vala"
	_tmp2_ = _tmp1_;
#line 120 "../src/Widgets/Key.vala"
	switch (_tmp2_) {
#line 120 "../src/Widgets/Key.vala"
		case WARBLE_MODELS_STATE_BLANK:
#line 267 "Key.c"
		{
			const gchar* _tmp3_ = NULL;
			WarbleWidgetsKeyKeyImage* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			GThemedIcon* _tmp7_;
			GThemedIcon* _tmp8_;
#line 122 "../src/Widgets/Key.vala"
			if (self->priv->is_pressed) {
#line 122 "../src/Widgets/Key.vala"
				_tmp3_ = ".key-pressed-blank";
#line 279 "Key.c"
			} else {
#line 122 "../src/Widgets/Key.vala"
				_tmp3_ = ".key-blank";
#line 283 "Key.c"
			}
#line 122 "../src/Widgets/Key.vala"
			_tmp4_ = self->priv->key;
#line 122 "../src/Widgets/Key.vala"
			_tmp5_ = g_strconcat (CONSTANTS_APP_ID, _tmp3_, NULL);
#line 122 "../src/Widgets/Key.vala"
			_tmp6_ = _tmp5_;
#line 122 "../src/Widgets/Key.vala"
			_tmp7_ = (GThemedIcon*) g_themed_icon_new (_tmp6_);
#line 122 "../src/Widgets/Key.vala"
			_tmp8_ = _tmp7_;
#line 122 "../src/Widgets/Key.vala"
			g_object_set ((GtkImage*) _tmp4_, "gicon", (GIcon*) _tmp8_, NULL);
#line 122 "../src/Widgets/Key.vala"
			_g_object_unref0 (_tmp8_);
#line 122 "../src/Widgets/Key.vala"
			_g_free0 (_tmp6_);
#line 123 "../src/Widgets/Key.vala"
			break;
#line 303 "Key.c"
		}
#line 120 "../src/Widgets/Key.vala"
		case WARBLE_MODELS_STATE_INCORRECT:
#line 307 "Key.c"
		{
			const gchar* _tmp9_ = NULL;
			WarbleWidgetsKeyKeyImage* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			GThemedIcon* _tmp13_;
			GThemedIcon* _tmp14_;
#line 125 "../src/Widgets/Key.vala"
			if (self->priv->is_pressed) {
#line 125 "../src/Widgets/Key.vala"
				_tmp9_ = ".key-pressed-incorrect";
#line 319 "Key.c"
			} else {
#line 125 "../src/Widgets/Key.vala"
				_tmp9_ = ".key-incorrect";
#line 323 "Key.c"
			}
#line 125 "../src/Widgets/Key.vala"
			_tmp10_ = self->priv->key;
#line 125 "../src/Widgets/Key.vala"
			_tmp11_ = g_strconcat (CONSTANTS_APP_ID, _tmp9_, NULL);
#line 125 "../src/Widgets/Key.vala"
			_tmp12_ = _tmp11_;
#line 125 "../src/Widgets/Key.vala"
			_tmp13_ = (GThemedIcon*) g_themed_icon_new (_tmp12_);
#line 125 "../src/Widgets/Key.vala"
			_tmp14_ = _tmp13_;
#line 125 "../src/Widgets/Key.vala"
			g_object_set ((GtkImage*) _tmp10_, "gicon", (GIcon*) _tmp14_, NULL);
#line 125 "../src/Widgets/Key.vala"
			_g_object_unref0 (_tmp14_);
#line 125 "../src/Widgets/Key.vala"
			_g_free0 (_tmp12_);
#line 126 "../src/Widgets/Key.vala"
			break;
#line 343 "Key.c"
		}
#line 120 "../src/Widgets/Key.vala"
		case WARBLE_MODELS_STATE_CLOSE:
#line 347 "Key.c"
		{
			const gchar* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
			WarbleWidgetsKeyKeyImage* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			GThemedIcon* _tmp22_;
			GThemedIcon* _tmp23_;
#line 128 "../src/Widgets/Key.vala"
			if (self->priv->is_pressed) {
#line 128 "../src/Widgets/Key.vala"
				_tmp15_ = ".key-pressed-close";
#line 362 "Key.c"
			} else {
#line 128 "../src/Widgets/Key.vala"
				_tmp15_ = ".key-close";
#line 366 "Key.c"
			}
#line 128 "../src/Widgets/Key.vala"
			if (high_contrast_mode) {
#line 128 "../src/Widgets/Key.vala"
				_tmp16_ = "-high-contrast";
#line 372 "Key.c"
			} else {
#line 128 "../src/Widgets/Key.vala"
				_tmp16_ = "";
#line 376 "Key.c"
			}
#line 128 "../src/Widgets/Key.vala"
			_tmp17_ = self->priv->key;
#line 128 "../src/Widgets/Key.vala"
			_tmp18_ = g_strconcat (CONSTANTS_APP_ID, _tmp15_, NULL);
#line 128 "../src/Widgets/Key.vala"
			_tmp19_ = _tmp18_;
#line 128 "../src/Widgets/Key.vala"
			_tmp20_ = g_strconcat (_tmp19_, _tmp16_, NULL);
#line 128 "../src/Widgets/Key.vala"
			_tmp21_ = _tmp20_;
#line 128 "../src/Widgets/Key.vala"
			_tmp22_ = (GThemedIcon*) g_themed_icon_new (_tmp21_);
#line 128 "../src/Widgets/Key.vala"
			_tmp23_ = _tmp22_;
#line 128 "../src/Widgets/Key.vala"
			g_object_set ((GtkImage*) _tmp17_, "gicon", (GIcon*) _tmp23_, NULL);
#line 128 "../src/Widgets/Key.vala"
			_g_object_unref0 (_tmp23_);
#line 128 "../src/Widgets/Key.vala"
			_g_free0 (_tmp21_);
#line 128 "../src/Widgets/Key.vala"
			_g_free0 (_tmp19_);
#line 129 "../src/Widgets/Key.vala"
			break;
#line 402 "Key.c"
		}
#line 120 "../src/Widgets/Key.vala"
		case WARBLE_MODELS_STATE_CORRECT:
#line 406 "Key.c"
		{
			const gchar* _tmp24_ = NULL;
			const gchar* _tmp25_ = NULL;
			WarbleWidgetsKeyKeyImage* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			GThemedIcon* _tmp31_;
			GThemedIcon* _tmp32_;
#line 131 "../src/Widgets/Key.vala"
			if (self->priv->is_pressed) {
#line 131 "../src/Widgets/Key.vala"
				_tmp24_ = ".key-pressed-correct";
#line 421 "Key.c"
			} else {
#line 131 "../src/Widgets/Key.vala"
				_tmp24_ = ".key-correct";
#line 425 "Key.c"
			}
#line 131 "../src/Widgets/Key.vala"
			if (high_contrast_mode) {
#line 131 "../src/Widgets/Key.vala"
				_tmp25_ = "-high-contrast";
#line 431 "Key.c"
			} else {
#line 131 "../src/Widgets/Key.vala"
				_tmp25_ = "";
#line 435 "Key.c"
			}
#line 131 "../src/Widgets/Key.vala"
			_tmp26_ = self->priv->key;
#line 131 "../src/Widgets/Key.vala"
			_tmp27_ = g_strconcat (CONSTANTS_APP_ID, _tmp24_, NULL);
#line 131 "../src/Widgets/Key.vala"
			_tmp28_ = _tmp27_;
#line 131 "../src/Widgets/Key.vala"
			_tmp29_ = g_strconcat (_tmp28_, _tmp25_, NULL);
#line 131 "../src/Widgets/Key.vala"
			_tmp30_ = _tmp29_;
#line 131 "../src/Widgets/Key.vala"
			_tmp31_ = (GThemedIcon*) g_themed_icon_new (_tmp30_);
#line 131 "../src/Widgets/Key.vala"
			_tmp32_ = _tmp31_;
#line 131 "../src/Widgets/Key.vala"
			g_object_set ((GtkImage*) _tmp26_, "gicon", (GIcon*) _tmp32_, NULL);
#line 131 "../src/Widgets/Key.vala"
			_g_object_unref0 (_tmp32_);
#line 131 "../src/Widgets/Key.vala"
			_g_free0 (_tmp30_);
#line 131 "../src/Widgets/Key.vala"
			_g_free0 (_tmp28_);
#line 132 "../src/Widgets/Key.vala"
			break;
#line 461 "Key.c"
		}
		default:
		{
#line 134 "../src/Widgets/Key.vala"
			g_assert_not_reached ();
#line 467 "Key.c"
		}
	}
}

gchar
warble_widgets_key_get_letter (WarbleWidgetsKey* self)
{
	gchar result;
#line 67 "../src/Widgets/Key.vala"
	g_return_val_if_fail (self != NULL, '\0');
#line 67 "../src/Widgets/Key.vala"
	result = self->priv->_letter;
#line 67 "../src/Widgets/Key.vala"
	return result;
#line 482 "Key.c"
}

static void
warble_widgets_key_set_letter (WarbleWidgetsKey* self,
                               gchar value)
{
	gchar old_value;
#line 67 "../src/Widgets/Key.vala"
	g_return_if_fail (self != NULL);
#line 67 "../src/Widgets/Key.vala"
	old_value = warble_widgets_key_get_letter (self);
#line 67 "../src/Widgets/Key.vala"
	if (old_value != value) {
#line 67 "../src/Widgets/Key.vala"
		self->priv->_letter = value;
#line 67 "../src/Widgets/Key.vala"
		g_object_notify_by_pspec ((GObject *) self, warble_widgets_key_properties[WARBLE_WIDGETS_KEY_LETTER_PROPERTY]);
#line 500 "Key.c"
	}
}

WarbleModelsState
warble_widgets_key_get_state (WarbleWidgetsKey* self)
{
	WarbleModelsState result;
#line 71 "../src/Widgets/Key.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 71 "../src/Widgets/Key.vala"
	result = self->priv->_state;
#line 71 "../src/Widgets/Key.vala"
	return result;
#line 514 "Key.c"
}

void
warble_widgets_key_set_state (WarbleWidgetsKey* self,
                              WarbleModelsState value)
{
#line 72 "../src/Widgets/Key.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/Widgets/Key.vala"
	self->priv->_state = value;
#line 72 "../src/Widgets/Key.vala"
	warble_widgets_key_update_icon (self);
#line 72 "../src/Widgets/Key.vala"
	g_object_notify_by_pspec ((GObject *) self, warble_widgets_key_properties[WARBLE_WIDGETS_KEY_STATE_PROPERTY]);
#line 529 "Key.c"
}

static inline gpointer
warble_widgets_key_key_image_get_instance_private (WarbleWidgetsKeyKeyImage* self)
{
	return G_STRUCT_MEMBER_P (self, WarbleWidgetsKeyKeyImage_private_offset);
}

static WarbleWidgetsKeyKeyImage*
warble_widgets_key_key_image_construct (GType object_type,
                                        gchar letter)
{
	WarbleWidgetsKeyKeyImage * self = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
#line 32 "../src/Widgets/Key.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new (CONSTANTS_APP_ID ".key-blank");
#line 32 "../src/Widgets/Key.vala"
	_tmp1_ = _tmp0_;
#line 32 "../src/Widgets/Key.vala"
	self = (WarbleWidgetsKeyKeyImage*) g_object_new (object_type, "gicon", _tmp1_, "pixel-size", WARBLE_WIDGETS_KEY_KEY_IMAGE_SIZE, "letter", letter, "y-offset", 0, "expand", FALSE, "halign", GTK_ALIGN_CENTER, NULL);
#line 32 "../src/Widgets/Key.vala"
	_g_object_unref0 (_tmp1_);
#line 31 "../src/Widgets/Key.vala"
	return self;
#line 555 "Key.c"
}

static WarbleWidgetsKeyKeyImage*
warble_widgets_key_key_image_new (gchar letter)
{
#line 31 "../src/Widgets/Key.vala"
	return warble_widgets_key_key_image_construct (WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE, letter);
#line 563 "Key.c"
}

static gboolean
warble_widgets_key_key_image_real_draw (GtkWidget* base,
                                        cairo_t* ctx)
{
	WarbleWidgetsKeyKeyImage * self;
	gboolean result;
#line 42 "../src/Widgets/Key.vala"
	self = (WarbleWidgetsKeyKeyImage*) base;
#line 42 "../src/Widgets/Key.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 43 "../src/Widgets/Key.vala"
	GTK_WIDGET_CLASS (warble_widgets_key_key_image_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_image_get_type (), GtkImage), ctx);
#line 44 "../src/Widgets/Key.vala"
	cairo_save (ctx);
#line 45 "../src/Widgets/Key.vala"
	warble_widgets_key_key_image_draw_letter (self, ctx);
#line 46 "../src/Widgets/Key.vala"
	cairo_restore (ctx);
#line 47 "../src/Widgets/Key.vala"
	result = FALSE;
#line 47 "../src/Widgets/Key.vala"
	return result;
#line 588 "Key.c"
}

static void
warble_widgets_key_key_image_draw_letter (WarbleWidgetsKeyKeyImage* self,
                                          cairo_t* ctx)
{
	GraniteDrawingColor* color = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GraniteDrawingColor* _tmp2_;
	GraniteDrawingColor* _tmp3_;
	cairo_text_extents_t extents = {0};
	gchar _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	cairo_text_extents_t _tmp7_ = {0};
	gdouble x = 0.0;
	cairo_text_extents_t _tmp8_;
	cairo_text_extents_t _tmp9_;
	gdouble y = 0.0;
	cairo_text_extents_t _tmp10_;
	cairo_text_extents_t _tmp11_;
	gint _tmp12_;
	gchar _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
#line 50 "../src/Widgets/Key.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/Widgets/Key.vala"
	g_return_if_fail (ctx != NULL);
#line 51 "../src/Widgets/Key.vala"
	_tmp0_ = warble_color_palette_get_value (WARBLE_COLOR_PALETTE_TEXT_COLOR);
#line 51 "../src/Widgets/Key.vala"
	_tmp1_ = _tmp0_;
#line 51 "../src/Widgets/Key.vala"
	_tmp2_ = granite_drawing_color_new_from_string (_tmp1_);
#line 51 "../src/Widgets/Key.vala"
	_tmp3_ = _tmp2_;
#line 51 "../src/Widgets/Key.vala"
	_g_free0 (_tmp1_);
#line 51 "../src/Widgets/Key.vala"
	color = _tmp3_;
#line 52 "../src/Widgets/Key.vala"
	cairo_set_source_rgb (ctx, color->R, color->G, color->B);
#line 54 "../src/Widgets/Key.vala"
	cairo_select_font_face (ctx, "Inter", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 55 "../src/Widgets/Key.vala"
	cairo_set_font_size (ctx, (gdouble) 15);
#line 58 "../src/Widgets/Key.vala"
	_tmp4_ = self->priv->_letter;
#line 58 "../src/Widgets/Key.vala"
	_tmp5_ = g_strdup_printf ("%c", _tmp4_);
#line 58 "../src/Widgets/Key.vala"
	_tmp6_ = _tmp5_;
#line 58 "../src/Widgets/Key.vala"
	cairo_text_extents (ctx, _tmp6_, &_tmp7_);
#line 58 "../src/Widgets/Key.vala"
	extents = _tmp7_;
#line 58 "../src/Widgets/Key.vala"
	_g_free0 (_tmp6_);
#line 59 "../src/Widgets/Key.vala"
	_tmp8_ = extents;
#line 59 "../src/Widgets/Key.vala"
	_tmp9_ = extents;
#line 59 "../src/Widgets/Key.vala"
	x = (WARBLE_WIDGETS_KEY_KEY_IMAGE_SIZE / 2) - ((_tmp8_.width / 2) + _tmp9_.x_bearing);
#line 60 "../src/Widgets/Key.vala"
	_tmp10_ = extents;
#line 60 "../src/Widgets/Key.vala"
	_tmp11_ = extents;
#line 60 "../src/Widgets/Key.vala"
	_tmp12_ = self->priv->_y_offset;
#line 60 "../src/Widgets/Key.vala"
	y = ((WARBLE_WIDGETS_KEY_KEY_IMAGE_SIZE / 2) - ((_tmp10_.height / 2) + _tmp11_.y_bearing)) + _tmp12_;
#line 61 "../src/Widgets/Key.vala"
	cairo_move_to (ctx, x, y);
#line 62 "../src/Widgets/Key.vala"
	_tmp13_ = self->priv->_letter;
#line 62 "../src/Widgets/Key.vala"
	_tmp14_ = g_strdup_printf ("%c", _tmp13_);
#line 62 "../src/Widgets/Key.vala"
	_tmp15_ = _tmp14_;
#line 62 "../src/Widgets/Key.vala"
	cairo_show_text (ctx, _tmp15_);
#line 62 "../src/Widgets/Key.vala"
	_g_free0 (_tmp15_);
#line 50 "../src/Widgets/Key.vala"
	_g_object_unref0 (color);
#line 677 "Key.c"
}

static gchar
warble_widgets_key_key_image_get_letter (WarbleWidgetsKeyKeyImage* self)
{
	gchar result;
#line 28 "../src/Widgets/Key.vala"
	g_return_val_if_fail (self != NULL, '\0');
#line 28 "../src/Widgets/Key.vala"
	result = self->priv->_letter;
#line 28 "../src/Widgets/Key.vala"
	return result;
#line 690 "Key.c"
}

static void
warble_widgets_key_key_image_set_letter (WarbleWidgetsKeyKeyImage* self,
                                         gchar value)
{
	gchar old_value;
#line 28 "../src/Widgets/Key.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Widgets/Key.vala"
	old_value = warble_widgets_key_key_image_get_letter (self);
#line 28 "../src/Widgets/Key.vala"
	if (old_value != value) {
#line 28 "../src/Widgets/Key.vala"
		self->priv->_letter = value;
#line 28 "../src/Widgets/Key.vala"
		g_object_notify_by_pspec ((GObject *) self, warble_widgets_key_key_image_properties[WARBLE_WIDGETS_KEY_KEY_IMAGE_LETTER_PROPERTY]);
#line 708 "Key.c"
	}
}

static gint
warble_widgets_key_key_image_get_y_offset (WarbleWidgetsKeyKeyImage* self)
{
	gint result;
#line 29 "../src/Widgets/Key.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 29 "../src/Widgets/Key.vala"
	result = self->priv->_y_offset;
#line 29 "../src/Widgets/Key.vala"
	return result;
#line 722 "Key.c"
}

static void
warble_widgets_key_key_image_set_y_offset (WarbleWidgetsKeyKeyImage* self,
                                           gint value)
{
	gint old_value;
#line 29 "../src/Widgets/Key.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Widgets/Key.vala"
	old_value = warble_widgets_key_key_image_get_y_offset (self);
#line 29 "../src/Widgets/Key.vala"
	if (old_value != value) {
#line 29 "../src/Widgets/Key.vala"
		self->priv->_y_offset = value;
#line 29 "../src/Widgets/Key.vala"
		g_object_notify_by_pspec ((GObject *) self, warble_widgets_key_key_image_properties[WARBLE_WIDGETS_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY]);
#line 740 "Key.c"
	}
}

static void
warble_widgets_key_key_image_class_init (WarbleWidgetsKeyKeyImageClass * klass,
                                         gpointer klass_data)
{
#line 24 "../src/Widgets/Key.vala"
	warble_widgets_key_key_image_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Widgets/Key.vala"
	g_type_class_adjust_private_offset (klass, &WarbleWidgetsKeyKeyImage_private_offset);
#line 24 "../src/Widgets/Key.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) warble_widgets_key_key_image_real_draw;
#line 24 "../src/Widgets/Key.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_warble_widgets_key_key_image_get_property;
#line 24 "../src/Widgets/Key.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_warble_widgets_key_key_image_set_property;
#line 24 "../src/Widgets/Key.vala"
	G_OBJECT_CLASS (klass)->finalize = warble_widgets_key_key_image_finalize;
#line 24 "../src/Widgets/Key.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARBLE_WIDGETS_KEY_KEY_IMAGE_LETTER_PROPERTY, warble_widgets_key_key_image_properties[WARBLE_WIDGETS_KEY_KEY_IMAGE_LETTER_PROPERTY] = g_param_spec_char ("letter", "letter", "letter", G_MININT8, G_MAXINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../src/Widgets/Key.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARBLE_WIDGETS_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY, warble_widgets_key_key_image_properties[WARBLE_WIDGETS_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY] = g_param_spec_int ("y-offset", "y-offset", "y-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 764 "Key.c"
}

static void
warble_widgets_key_key_image_instance_init (WarbleWidgetsKeyKeyImage * self,
                                            gpointer klass)
{
#line 24 "../src/Widgets/Key.vala"
	self->priv = warble_widgets_key_key_image_get_instance_private (self);
#line 773 "Key.c"
}

static void
warble_widgets_key_key_image_finalize (GObject * obj)
{
	WarbleWidgetsKeyKeyImage * self;
#line 24 "../src/Widgets/Key.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE, WarbleWidgetsKeyKeyImage);
#line 24 "../src/Widgets/Key.vala"
	G_OBJECT_CLASS (warble_widgets_key_key_image_parent_class)->finalize (obj);
#line 784 "Key.c"
}

static GType
warble_widgets_key_key_image_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WarbleWidgetsKeyKeyImageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) warble_widgets_key_key_image_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WarbleWidgetsKeyKeyImage), 0, (GInstanceInitFunc) warble_widgets_key_key_image_instance_init, NULL };
	GType warble_widgets_key_key_image_type_id;
	warble_widgets_key_key_image_type_id = g_type_register_static (gtk_image_get_type (), "WarbleWidgetsKeyKeyImage", &g_define_type_info, 0);
	WarbleWidgetsKeyKeyImage_private_offset = g_type_add_instance_private (warble_widgets_key_key_image_type_id, sizeof (WarbleWidgetsKeyKeyImagePrivate));
	return warble_widgets_key_key_image_type_id;
}

static GType
warble_widgets_key_key_image_get_type (void)
{
	static volatile gsize warble_widgets_key_key_image_type_id__once = 0;
	if (g_once_init_enter (&warble_widgets_key_key_image_type_id__once)) {
		GType warble_widgets_key_key_image_type_id;
		warble_widgets_key_key_image_type_id = warble_widgets_key_key_image_get_type_once ();
		g_once_init_leave (&warble_widgets_key_key_image_type_id__once, warble_widgets_key_key_image_type_id);
	}
	return warble_widgets_key_key_image_type_id__once;
}

static void
_vala_warble_widgets_key_key_image_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	WarbleWidgetsKeyKeyImage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE, WarbleWidgetsKeyKeyImage);
#line 24 "../src/Widgets/Key.vala"
	switch (property_id) {
#line 24 "../src/Widgets/Key.vala"
		case WARBLE_WIDGETS_KEY_KEY_IMAGE_LETTER_PROPERTY:
#line 24 "../src/Widgets/Key.vala"
		g_value_set_schar (value, warble_widgets_key_key_image_get_letter (self));
#line 24 "../src/Widgets/Key.vala"
		break;
#line 24 "../src/Widgets/Key.vala"
		case WARBLE_WIDGETS_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY:
#line 24 "../src/Widgets/Key.vala"
		g_value_set_int (value, warble_widgets_key_key_image_get_y_offset (self));
#line 24 "../src/Widgets/Key.vala"
		break;
#line 831 "Key.c"
		default:
#line 24 "../src/Widgets/Key.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Widgets/Key.vala"
		break;
#line 837 "Key.c"
	}
}

static void
_vala_warble_widgets_key_key_image_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	WarbleWidgetsKeyKeyImage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE, WarbleWidgetsKeyKeyImage);
#line 24 "../src/Widgets/Key.vala"
	switch (property_id) {
#line 24 "../src/Widgets/Key.vala"
		case WARBLE_WIDGETS_KEY_KEY_IMAGE_LETTER_PROPERTY:
#line 24 "../src/Widgets/Key.vala"
		warble_widgets_key_key_image_set_letter (self, g_value_get_schar (value));
#line 24 "../src/Widgets/Key.vala"
		break;
#line 24 "../src/Widgets/Key.vala"
		case WARBLE_WIDGETS_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY:
#line 24 "../src/Widgets/Key.vala"
		warble_widgets_key_key_image_set_y_offset (self, g_value_get_int (value));
#line 24 "../src/Widgets/Key.vala"
		break;
#line 863 "Key.c"
		default:
#line 24 "../src/Widgets/Key.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Widgets/Key.vala"
		break;
#line 869 "Key.c"
	}
}

static gboolean
_warble_widgets_key___lambda15_ (WarbleWidgetsKey* self,
                                 GdkEventButton* event)
{
	WarbleWidgetsKeyKeyImage* _tmp0_;
	gchar _tmp1_;
	gboolean result;
#line 90 "../src/Widgets/Key.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 92 "../src/Widgets/Key.vala"
	if (event->type != GDK_BUTTON_PRESS) {
#line 93 "../src/Widgets/Key.vala"
		result = FALSE;
#line 93 "../src/Widgets/Key.vala"
		return result;
#line 888 "Key.c"
	}
#line 95 "../src/Widgets/Key.vala"
	self->priv->is_pressed = TRUE;
#line 96 "../src/Widgets/Key.vala"
	_tmp0_ = self->priv->key;
#line 96 "../src/Widgets/Key.vala"
	warble_widgets_key_key_image_set_y_offset (_tmp0_, 2);
#line 97 "../src/Widgets/Key.vala"
	warble_widgets_key_update_icon (self);
#line 98 "../src/Widgets/Key.vala"
	_tmp1_ = self->priv->_letter;
#line 98 "../src/Widgets/Key.vala"
	g_signal_emit (self, warble_widgets_key_signals[WARBLE_WIDGETS_KEY_CLICKED_SIGNAL], 0, _tmp1_);
#line 902 "Key.c"
}

static gboolean
__warble_widgets_key___lambda15__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                GdkEventButton* event,
                                                                gpointer self)
{
	gboolean result;
	result = _warble_widgets_key___lambda15_ ((WarbleWidgetsKey*) self, event);
#line 90 "../src/Widgets/Key.vala"
	return result;
#line 914 "Key.c"
}

static gboolean
_warble_widgets_key___lambda16_ (WarbleWidgetsKey* self)
{
	WarbleWidgetsKeyKeyImage* _tmp0_;
#line 101 "../src/Widgets/Key.vala"
	self->priv->is_pressed = FALSE;
#line 102 "../src/Widgets/Key.vala"
	_tmp0_ = self->priv->key;
#line 102 "../src/Widgets/Key.vala"
	warble_widgets_key_key_image_set_y_offset (_tmp0_, 0);
#line 103 "../src/Widgets/Key.vala"
	warble_widgets_key_update_icon (self);
#line 929 "Key.c"
}

static gboolean
__warble_widgets_key___lambda16__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                  GdkEventButton* event,
                                                                  gpointer self)
{
	gboolean result;
	result = _warble_widgets_key___lambda16_ ((WarbleWidgetsKey*) self);
#line 100 "../src/Widgets/Key.vala"
	return result;
#line 941 "Key.c"
}

static gboolean
_warble_widgets_key___lambda17_ (WarbleWidgetsKey* self)
{
	gchar _tmp0_;
#line 108 "../src/Widgets/Key.vala"
	_tmp0_ = self->priv->_letter;
#line 108 "../src/Widgets/Key.vala"
	g_signal_emit (self, warble_widgets_key_signals[WARBLE_WIDGETS_KEY_CLICKED_SIGNAL], 0, _tmp0_);
#line 952 "Key.c"
}

static gboolean
__warble_widgets_key___lambda17__gtk_widget_touch_event (GtkWidget* _sender,
                                                         GdkEvent* event,
                                                         gpointer self)
{
	gboolean result;
	result = _warble_widgets_key___lambda17_ ((WarbleWidgetsKey*) self);
#line 105 "../src/Widgets/Key.vala"
	return result;
#line 964 "Key.c"
}

static void
_warble_widgets_key___lambda18_ (WarbleWidgetsKey* self,
                                 const gchar* key)
{
#line 111 "../src/Widgets/Key.vala"
	g_return_if_fail (key != NULL);
#line 112 "../src/Widgets/Key.vala"
	if (g_strcmp0 (key, "high-contrast-mode") == 0) {
#line 113 "../src/Widgets/Key.vala"
		warble_widgets_key_update_icon (self);
#line 977 "Key.c"
	}
}

static void
__warble_widgets_key___lambda18__g_settings_changed (GSettings* _sender,
                                                     const gchar* key,
                                                     gpointer self)
{
#line 111 "../src/Widgets/Key.vala"
	_warble_widgets_key___lambda18_ ((WarbleWidgetsKey*) self, key);
#line 988 "Key.c"
}

static GObject *
warble_widgets_key_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WarbleWidgetsKey * self;
	gchar _tmp0_;
	WarbleWidgetsKeyKeyImage* _tmp1_;
	WarbleWidgetsKeyKeyImage* _tmp2_;
	GSettings* _tmp3_;
#line 84 "../src/Widgets/Key.vala"
	parent_class = G_OBJECT_CLASS (warble_widgets_key_parent_class);
#line 84 "../src/Widgets/Key.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 84 "../src/Widgets/Key.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARBLE_WIDGETS_TYPE_KEY, WarbleWidgetsKey);
#line 85 "../src/Widgets/Key.vala"
	_tmp0_ = self->priv->_letter;
#line 85 "../src/Widgets/Key.vala"
	_tmp1_ = warble_widgets_key_key_image_new (_tmp0_);
#line 85 "../src/Widgets/Key.vala"
	g_object_ref_sink (_tmp1_);
#line 85 "../src/Widgets/Key.vala"
	_g_object_unref0 (self->priv->key);
#line 85 "../src/Widgets/Key.vala"
	self->priv->key = _tmp1_;
#line 86 "../src/Widgets/Key.vala"
	_tmp2_ = self->priv->key;
#line 86 "../src/Widgets/Key.vala"
	g_object_set ((GtkContainer*) self, "child", (GtkWidget*) _tmp2_, NULL);
#line 89 "../src/Widgets/Key.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) ((GDK_BUTTON_PRESS_MASK | GDK_TOUCH_MASK) | GDK_BUTTON_RELEASE_MASK));
#line 90 "../src/Widgets/Key.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) __warble_widgets_key___lambda15__gtk_widget_button_press_event, self, 0);
#line 100 "../src/Widgets/Key.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-release-event", (GCallback) __warble_widgets_key___lambda16__gtk_widget_button_release_event, self, 0);
#line 105 "../src/Widgets/Key.vala"
	g_signal_connect_object ((GtkWidget*) self, "touch-event", (GCallback) __warble_widgets_key___lambda17__gtk_widget_touch_event, self, 0);
#line 111 "../src/Widgets/Key.vala"
	_tmp3_ = warble_application_settings;
#line 111 "../src/Widgets/Key.vala"
	g_signal_connect_object (_tmp3_, "changed", (GCallback) __warble_widgets_key___lambda18__g_settings_changed, self, 0);
#line 84 "../src/Widgets/Key.vala"
	return obj;
#line 1037 "Key.c"
}

static void
warble_widgets_key_class_init (WarbleWidgetsKeyClass * klass,
                               gpointer klass_data)
{
#line 22 "../src/Widgets/Key.vala"
	warble_widgets_key_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/Key.vala"
	g_type_class_adjust_private_offset (klass, &WarbleWidgetsKey_private_offset);
#line 22 "../src/Widgets/Key.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_warble_widgets_key_get_property;
#line 22 "../src/Widgets/Key.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_warble_widgets_key_set_property;
#line 22 "../src/Widgets/Key.vala"
	G_OBJECT_CLASS (klass)->constructor = warble_widgets_key_constructor;
#line 22 "../src/Widgets/Key.vala"
	G_OBJECT_CLASS (klass)->finalize = warble_widgets_key_finalize;
#line 22 "../src/Widgets/Key.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARBLE_WIDGETS_KEY_LETTER_PROPERTY, warble_widgets_key_properties[WARBLE_WIDGETS_KEY_LETTER_PROPERTY] = g_param_spec_char ("letter", "letter", "letter", G_MININT8, G_MAXINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/Key.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARBLE_WIDGETS_KEY_STATE_PROPERTY, warble_widgets_key_properties[WARBLE_WIDGETS_KEY_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", WARBLE_MODELS_TYPE_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Widgets/Key.vala"
	warble_widgets_key_signals[WARBLE_WIDGETS_KEY_CLICKED_SIGNAL] = g_signal_new ("clicked", WARBLE_WIDGETS_TYPE_KEY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__CHAR, G_TYPE_NONE, 1, G_TYPE_CHAR);
#line 1062 "Key.c"
}

static void
warble_widgets_key_instance_init (WarbleWidgetsKey * self,
                                  gpointer klass)
{
#line 22 "../src/Widgets/Key.vala"
	self->priv = warble_widgets_key_get_instance_private (self);
#line 69 "../src/Widgets/Key.vala"
	self->priv->_state = WARBLE_MODELS_STATE_BLANK;
#line 76 "../src/Widgets/Key.vala"
	self->priv->is_pressed = FALSE;
#line 1075 "Key.c"
}

static void
warble_widgets_key_finalize (GObject * obj)
{
	WarbleWidgetsKey * self;
#line 22 "../src/Widgets/Key.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARBLE_WIDGETS_TYPE_KEY, WarbleWidgetsKey);
#line 75 "../src/Widgets/Key.vala"
	_g_object_unref0 (self->priv->key);
#line 22 "../src/Widgets/Key.vala"
	G_OBJECT_CLASS (warble_widgets_key_parent_class)->finalize (obj);
#line 1088 "Key.c"
}

static GType
warble_widgets_key_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WarbleWidgetsKeyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) warble_widgets_key_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WarbleWidgetsKey), 0, (GInstanceInitFunc) warble_widgets_key_instance_init, NULL };
	GType warble_widgets_key_type_id;
	warble_widgets_key_type_id = g_type_register_static (gtk_event_box_get_type (), "WarbleWidgetsKey", &g_define_type_info, 0);
	WarbleWidgetsKey_private_offset = g_type_add_instance_private (warble_widgets_key_type_id, sizeof (WarbleWidgetsKeyPrivate));
	return warble_widgets_key_type_id;
}

GType
warble_widgets_key_get_type (void)
{
	static volatile gsize warble_widgets_key_type_id__once = 0;
	if (g_once_init_enter (&warble_widgets_key_type_id__once)) {
		GType warble_widgets_key_type_id;
		warble_widgets_key_type_id = warble_widgets_key_get_type_once ();
		g_once_init_leave (&warble_widgets_key_type_id__once, warble_widgets_key_type_id);
	}
	return warble_widgets_key_type_id__once;
}

static void
_vala_warble_widgets_key_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	WarbleWidgetsKey * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARBLE_WIDGETS_TYPE_KEY, WarbleWidgetsKey);
#line 22 "../src/Widgets/Key.vala"
	switch (property_id) {
#line 22 "../src/Widgets/Key.vala"
		case WARBLE_WIDGETS_KEY_LETTER_PROPERTY:
#line 22 "../src/Widgets/Key.vala"
		g_value_set_schar (value, warble_widgets_key_get_letter (self));
#line 22 "../src/Widgets/Key.vala"
		break;
#line 22 "../src/Widgets/Key.vala"
		case WARBLE_WIDGETS_KEY_STATE_PROPERTY:
#line 22 "../src/Widgets/Key.vala"
		g_value_set_enum (value, warble_widgets_key_get_state (self));
#line 22 "../src/Widgets/Key.vala"
		break;
#line 1135 "Key.c"
		default:
#line 22 "../src/Widgets/Key.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/Key.vala"
		break;
#line 1141 "Key.c"
	}
}

static void
_vala_warble_widgets_key_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	WarbleWidgetsKey * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARBLE_WIDGETS_TYPE_KEY, WarbleWidgetsKey);
#line 22 "../src/Widgets/Key.vala"
	switch (property_id) {
#line 22 "../src/Widgets/Key.vala"
		case WARBLE_WIDGETS_KEY_LETTER_PROPERTY:
#line 22 "../src/Widgets/Key.vala"
		warble_widgets_key_set_letter (self, g_value_get_schar (value));
#line 22 "../src/Widgets/Key.vala"
		break;
#line 22 "../src/Widgets/Key.vala"
		case WARBLE_WIDGETS_KEY_STATE_PROPERTY:
#line 22 "../src/Widgets/Key.vala"
		warble_widgets_key_set_state (self, g_value_get_enum (value));
#line 22 "../src/Widgets/Key.vala"
		break;
#line 1167 "Key.c"
		default:
#line 22 "../src/Widgets/Key.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/Key.vala"
		break;
#line 1173 "Key.c"
	}
}

